GTK+ 2.0 Tutorial
<<< Previous |  | Next >>>

# Getting Started

The first thing to do, of course, is download the GTK source and install it. You can always get the latest version from ftp.gtk.org. You can also view other sources of GTK information on http://www.gtk.org/. GTK uses GNU autoconf for configuration. Once untar'd, type `./configure --help` to see a list of options.

The GTK source distribution also contains the complete source to all of the examples used in this tutorial, along with Makefiles to aid compilation.

To begin our introduction to GTK, we'll start with the simplest program possible. This program will create a 200x200 pixel window and has no way of exiting except to be killed by using the shell.

    #include <gtk/gtk.h>

    int main( int   argc,
              char *argv[] )
    {
        GtkWidget *window;

        gtk_init (&argc, &argv);

        window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
        gtk_widget_show  (window);

        gtk_main ();

        return 0;
    }

You can compile the above program with gcc using:

`gcc base.c -o base `pkg-config --cflags --libs gtk+-2.0``

The meaning of the unusual compilation options is explained below in Compiling Hello World.

All programs will of course include `gtk/gtk.h` which declares the variables, functions, structures, etc. that will be used in your GTK application.

The next line:

    gtk_init (&argc, &argv);

calls the function gtk_init(gint *argc, gchar ***argv) which will be called in all GTK applications. This sets up a few things for us such as the default visual and color map and then proceeds to call gdk_init(gint *argc, gchar ***argv). This function initializes the library for use, sets up default signal handlers, and checks the arguments passed to your application on the command line, looking for one of the following:

- `--gtk-module`
- `--g-fatal-warnings`
- `--gtk-debug`
- `--gtk-no-debug`
- `--gdk-debug`
- `--gdk-no-debug`
- `--display`
- `--sync`
- `--name`
- `--class`

It removes these from the argument list, leaving anything it does not recognize for your application to parse or ignore. This creates a set of standard arguments accepted by all GTK applications.

The next two lines of code create and display a window.

      window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      gtk_widget_show (window);

The `GTK_WINDOW_TOPLEVEL` argument specifies that we want the window to undergo window manager decoration and placement. Rather than create a window of 0x0 size, a window without children is set to 200x200 by default so you can still manipulate it.

The gtk_widget_show() function lets GTK know that we are done setting the attributes of this widget, and that it can display it.

The last line enters the GTK main processing loop.

      gtk_main ();

gtk_main() is another call you will see in every GTK application. When control reaches this point, GTK will sleep waiting for X events (such as button or key presses), timeouts, or file IO notifications to occur. In our simple example, however, events are ignored.

# Hello World in GTK

Now for a program with a widget (a button). It's the classic hello world a la GTK.

    #include <gtk/gtk.h>

    /* This is a callback function. The data arguments are ignored
     * in this example. More on callbacks below. */
    void hello( GtkWidget *widget,
                gpointer   data )
    {
        g_print ("Hello World\n");
    }

    gint delete_event( GtkWidget *widget,
                       GdkEvent  *event,
    		   gpointer   data )
    {
        /* If you return FALSE in the "delete_event" signal handler,
         * GTK will emit the "destroy" signal. Returning TRUE means
         * you don't want the window to be destroyed.
         * This is useful for popping up 'are you sure you want to quit?'
         * type dialogs. */

        g_print ("delete event occurred\n");

        /* Change TRUE to FALSE and the main window will be destroyed with
         * a "delete_event". */

        return TRUE;
    }

    /* Another callback */
    void destroy( GtkWidget *widget,
                  gpointer   data )
    {
        gtk_main_quit ();
    }

    int main( int   argc,
              char *argv[] )
    {
        /* GtkWidget is the storage type for widgets */
        GtkWidget *window;
        GtkWidget *button;

        /* This is called in all GTK applications. Arguments are parsed
         * from the command line and are returned to the application. */
        gtk_init (&argc, &argv);

        /* create a new window */
        window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

        /* When the window is given the "delete_event" signal (this is given
         * by the window manager, usually by the "close" option, or on the
         * titlebar), we ask it to call the delete_event () function
         * as defined above. The data passed to the callback
         * function is NULL and is ignored in the callback function. */
        g_signal_connect (G_OBJECT (window), "delete_event",
    		      G_CALLBACK (delete_event), NULL);

        /* Here we connect the "destroy" event to a signal handler.
         * This event occurs when we call gtk_widget_destroy() on the window,
         * or if we return FALSE in the "delete_event" callback. */
        g_signal_connect (G_OBJECT (window), "destroy",
    		      G_CALLBACK (destroy), NULL);

        /* Sets the border width of the window. */
        gtk_container_set_border_width (GTK_CONTAINER (window), 10);

        /* Creates a new button with the label "Hello World". */
        button = gtk_button_new_with_label ("Hello World");

        /* When the button receives the "clicked" signal, it will call the
         * function hello() passing it NULL as its argument.  The hello()
         * function is defined above. */
        g_signal_connect (G_OBJECT (button), "clicked",
    		      G_CALLBACK (hello), NULL);

        /* This will cause the window to be destroyed by calling
         * gtk_widget_destroy(window) when "clicked".  Again, the destroy
         * signal could come from here, or the window manager. */
        g_signal_connect_swapped (G_OBJECT (button), "clicked",
    			      G_CALLBACK (gtk_widget_destroy),
                                  window);

        /* This packs the button into the window (a gtk container). */
        gtk_container_add (GTK_CONTAINER (window), button);

        /* The final step is to display this newly created widget. */
        gtk_widget_show (button);

        /* and the window */
        gtk_widget_show (window);

        /* All GTK applications must have a gtk_main(). Control ends here
         * and waits for an event to occur (like a key press or
         * mouse event). */
        gtk_main ();

        return 0;
    }

<<< Previous | Home | Next >>>
Introduction |  | Compiling Hello World